#define F_CPU 14745600UL
#include <avr/io.h>
#include <string.h>
#include <stdio.h> 
#include <util/delay.h>
#include <stdint.h>
#include <avr/interrupt.h>
#include "knihovnaLCD.c"
#include "Vyroba.c"


//*******************************************************************************************

#define setb(port,pin)    port |= 1<<pin    //nastaven bitu
#define clrb(port,pin)    port &= ~(1<<pin) //nulovn bitu
#define negb(port,pin)    port ^= 1<<pin    //negace bitu

//*******************************************************************************************

volatile unsigned char start=0;
volatile unsigned char stop=0;
volatile unsigned char bezi=0;

ISR(INT0_vect)   //obsluha preruseni tlacitka stop
{
stop=1;			 //zastaven vykonvn programu
start=0;		 //linka stoj
bezi=0;			 //linka byla zastavena
stop_stroje();   //funkce pro zastaven a najet do vchoz polohu
}

ISR(INT1_vect)   //obsluha preruseni tlacitka start
{
start=1;         //rozjet linky
stop=0;			 //povoleno vykonvn programu

if (bezi==0)      //provede se pokud linka stoj
	{
		poprve=1; //nastaven poprve na 1 pokud linka nen v provozu
	}
}

int main(void)
{

_delay_ms(100); //init delay

device_init();
welcome_scr();

char potvrzeno=0;
char i=0; //misto v menu
char N[9];
char CH[9];
char x=4;

while (1)
{

if(start==0) 									//ochrana proti pohybovani v menu za provozu
{

//pohyb v menu	

	if bit_is_set(PIND,6)   					//stisknut tlatka nahoru
	{
		if ((i>=0) & (i<x)) 					//podmnka jestli i je v povolemm rozsahu
		{ 
		i++;									//pohyb v menu nahoru
		}
	}
	if bit_is_set(PIND,5)   					//stisknut tlatka dolu
	{
		if ((i>0) & (i<=x)) 					//podmnka jestli i je v povolemm rozsahu
		{ 
		i--;									//pohyb v menu dolu
		}
	}

  switch (i)									//pepnut na nvst i
  {
  	case 1:	LCD_Clear();  						//vymazn displeje
			_delay_ms(2); 						//spodn pro smazn displeje
	     	LCD_Position(0 , 0);  				//pozice pro zapsn textu
       	    LCD_WriteString("R50/63N:30,CH:26");//zapsn textu na displej
			if (potvrzeno==4)  					//vypsn potvrzen, pokud bylo stisknuto tlatko ok
			{
			  LCD_Position(1 , 0);				//pozice pro vypsn na diplej
       		  LCD_WriteString("Potvrzeno :-)"); //vypsn na diplej
		      _delay_ms(250);  			     	//delay kvli stisknut tlatka (aby se pietlo jen jednou)
			}
			else   								//jinak se na spodn dek zape toto
			{    
			LCD_Position(1 , 0);				//pozice pro vypsn na diplej
       		LCD_WriteString("Vybrat, OK?");		//vypsn na diplej
		    _delay_ms(250);      				//spodn kvli stisknut tlatka (aby se pietlo jen jednou)
			}
			
			if bit_is_set(PIND,4)  				//tlacitko OK
			{
   			  LCD_Clear();						//vymazn displeje
  			  _delay_ms(2);  					//delay pro smazn displeje
			  LCD_Position(0 , 0);				//pozice pro zapsn textu
			  LCD_WriteString("Potvrzeno!");    //vypsn na diplej
			  potvrzeno=i;  					//nastav promnnou, podle kter se vybr dc program vyroby
		      bezi=1;       					//probhn programu
			  poprve=1;	 						//spout se poprv
    		  _delay_ms(2000);    				//spodn pro zobrazen textu
			}	
			break;								//ukonen nvest case 1
			
		  	
  	case 2: LCD_Clear();
			_delay_ms(2);
	     	LCD_Position(0 , 0);
       		LCD_WriteString("R50/63N:20,CH:16");
			if (potvrzeno==2)
			{
				LCD_Position(1 , 0);
       			LCD_WriteString("Potvrzeno :-)"); 
		    	_delay_ms(250);
			}
			else{
			LCD_Position(1 , 0);
       		LCD_WriteString("Vybrat, OK?");
		    _delay_ms(250);
			}
			if bit_is_set(PIND,4)  //tlacitko OK
			{
   				LCD_Clear();
  				_delay_ms(2);
				LCD_Position(0 , 0);
				LCD_WriteString("Potvrzeno!");
				potvrzeno=i;
				bezi=1;
				poprve=1;
    			_delay_ms(2000);
			}
			break;
  
  	case 3: LCD_Clear();
			_delay_ms(2);
			LCD_Position(0 , 0);
       	    LCD_WriteString("R50/63N:25,CH:21");
			if (potvrzeno==3)
			{
				LCD_Position(1 , 0);
       			LCD_WriteString("Potvrzeno :-)"); 
		    	_delay_ms(250);
			}
			else{
			LCD_Position(1 , 0);
       		LCD_WriteString("Vybrat, OK?");
		    _delay_ms(250);
			}
			if bit_is_set(PIND,4)  //tlacitko OK
			{
   				LCD_Clear();
  				_delay_ms(2);
				LCD_Position(0 , 0);
				LCD_WriteString("Potvrzeno!");
				potvrzeno=i;
				bezi=1;
				poprve=1;
    			_delay_ms(2000);
			}
			break;
	
	case 4: LCD_Clear();    //vymazn displeje
			_delay_ms(2);   //delay pro smazn displeje
	    	LCD_Position(0 , 0);  //pozice pro zapsn textu
       		LCD_WriteString("R50/63N:15,CH:11"); //zapsn textu na displej
			if (potvrzeno==1)   //vypsn potvrzen programu na spodn dek, pokud bylo stisknuto tlatko ok
			{
				LCD_Position(1 , 0);
       			LCD_WriteString("Potvrzeno :-)"); 
		    	_delay_ms(250);  //delay kvli stisknut tlatka (aby se pietlo jen jednou)
			}
			else{               //jinak se na spodn dek zape toto
			LCD_Position(1 , 0);
       		LCD_WriteString("Vybrat, OK?");
		    _delay_ms(250);
			}
			if bit_is_set(PIND,4)  // potvrzen tlacitkem OK
			{
   				LCD_Clear();
  				_delay_ms(2);
				LCD_Position(0 , 0);
				LCD_WriteString("Potvrzeno!");
				potvrzeno=i;  //nastav promenou, podle ktere se vybr program vyroby
				bezi=1;
				poprve=1;         
				_delay_ms(2000);
			}
			break;

	default:break;
 	
  }

} // if start ==0


if ((start==1) & (stop==0)) 				//sputn dcho program vroby pokud bylo stisknuto start
{

switch (potvrzeno)							//pepnut na nvst potvrzeno
{

///////////////////////////////////////////////////////////////////////////////
case 1:  //////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

if (poprve==1)								//proveden podmnky
{
	poprve=0;								//zakzn cyklu for 
	for (int j=300; j>=0; j--)			//as natkn forem 
	{
		if (stop==1){ break;}  		 		//zastaven stroje pokud bylo vyvolno peruen
		LCD_Clear();						//vymazn displeje
  		_delay_ms(2);						//spodn pro smazn displeje
		sprintf(N,"N=%d",j/10); 	 		//odpoet asu na displeji po sekundch
		LCD_Position(0 , 0);				//pozice pro zapsn textu
       	LCD_WriteString("R50/63 Pracuji!"); //zapsn na displej
		LCD_Position(1 , 0);				//pozice pro zapsn textu
   		LCD_WriteString(N);					//zapsn na displej
		if (j==8)  {setb(PORTB,7);}  		//zaven forem 
		_delay_ms(100);						//spodn (as cyklu)
		if (stop==1){break;}  				//zastaven stroje pokud bylo vyvolno peruen
	}
}

for (int j=300;j>=0;j--)				 //30s cyklus 
{
	if (stop==1){break;}          		 //zastaven stroje pokud bylo vyvolno peruen
	if (j==300){setb(PORTB,6);}  		 //N - uznut (v ase 30s)
	if (j==297){setb(PORTB,5);}   		 //Tlak - odjet pojezdem na plnn druh formy 29,7s
	if (j==270){setb(PORTB,4);}  		 //Trny 1 - zajet (v ase 27s)
	if (j==10) {clrb(PORTB,4);}  		 //Trny 1 - odjet (v ase 1s)
	if (j==8)  {clrb(PORTB,7);}  	     //Tlak - uzaven druhch forem, oteven prvnch v ase 0,8s
	sprintf(N,"N=%d,",j/10);			 //vpis odpotvn
	if ((j<=270) & (j>=10))				 //26s odpoet doby chlazen 
	{
		sprintf(CH,"CH=%d",(j-10)/10); 	 //vpis odetn doby chlazen
	}
	else
	{
		sprintf(CH,"CH=%d", 26);  		 //vpis doby chlazen
	}
	LCD_Clear();						 //vymazn displeje
  	_delay_ms(2);						 //spodn pro smazn displeje
	LCD_Position(0 , 0);				 //pozice pro zapsn textu
    LCD_WriteString("R50/63 Pracuji!");	 //zapsn na displej
	LCD_Position(1 , 0);				 //pozice pro zapsn textu
   	LCD_WriteString(N);					 //zapsn na displej
	LCD_WriteString(CH);				 //zapsn na displej
	_delay_ms(100);            			 //spodn pro potn asu 300*100=3000ms = 30s
	if (stop==1){break;}   				 //zastaven stroje po stisknut tlaitka stop
}

for (int j=300;j>=0;j--) 		  		 //natkn + chlazen forem 2
{
	if (stop==1){break;}				 //zastaven stroje pokud bylo vyvolno peruen
	if (j==300){clrb(PORTB,6);}   		 //N - uznut (v ase 30s)
	if (j==297){clrb(PORTB,5);}   		 //Pojezd - odjet na plnn druh formy
	if (j==270){setb(PORTB,3);} 		 //Trny 2 - zajet (v ase 27s)
	if (j==10) {clrb(PORTB,3);}   		 //Trny 2 - odjet (v ase 1s)
	if (j==8)  {setb(PORTB,7);}  		 //Tlak - uzaven prvnch forem, oteven druhch v ase 0,8s
	sprintf(N,"N=%d,",j/10);
	if ((j<=270) & (j>10))
	{
		sprintf(CH,"CH=%d",(j-10)/10); //vpis doby chlazen
	}
	else
	{
		sprintf(CH,"CH=%d", 26);
	}
	LCD_Clear();
  	_delay_ms(2);
	LCD_Position(0 , 0);
   	LCD_WriteString("R50/63 Pracuji!");
	LCD_Position(1 , 0);
   	LCD_WriteString(N);
	LCD_WriteString(CH);
	_delay_ms(100);
	if (stop==1){break;}
}	
break;

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
case 2:  //////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////


if (poprve==1)
{
	poprve=0;
	for (int j=200; j>0; j--) //natkn forem a chlazen
	{
		if (stop==1){ break;}
		LCD_Clear();
  		_delay_ms(2);
		sprintf(N,"N=%d",j/10);
		LCD_Position(0 , 0);
       	LCD_WriteString("R50/63 Pracuji!");
		LCD_Position(1 , 0);
   		LCD_WriteString(N);
		if (j==8)  {setb(PORTB,7);}  //zaven forem 
		_delay_ms(100);
		if (stop==1){break;}
	}
}

for (int j=200;j>0;j--)
{
	if (stop==1){break;}	
	if (j==200){setb(PORTB,6);}   //uznut noem
	if (j==197){setb(PORTB,5);}   //odjet na plnn druh formy
	if (j==170){setb(PORTB,4);}   //zajet 1. trn
	if (j==10) {clrb(PORTB,4);}   //odjet 1. trn
	if (j==8)  {clrb(PORTB,7);}   //uzaven druhch forem, oteven prvnch
	sprintf(N,"N=%d,",j/10);
	if ((j<=170) & (j>10))
	{
		sprintf(CH,"CH=%d",(j-10)/10); //vpis doby chlazen
	}
	else
	{
		sprintf(CH,"CH=%d", 16);
	}
	LCD_Clear();
  	_delay_ms(2);
	LCD_Position(0 , 0);
    LCD_WriteString("R50/63 Pracuji!");
	LCD_Position(1 , 0);
   	LCD_WriteString(N);
	LCD_WriteString(CH);
	_delay_ms(100);
	if (stop==1){break;}
}

for (int j=200;j>0;j--) //natkn + chlazen forem 2
{
	if (stop==1){break;}
	if (j==200){clrb(PORTB,6);}   //uznut noem
	if (j==197){clrb(PORTB,5);}   //odjet na plnn druh formy
	if (j==170){setb(PORTB,3);}   //zajet 2. trn
	if (j==10) {clrb(PORTB,3);}   //odjet 2. trn
	if (j==8)  {setb(PORTB,7);}   //uzaven forem
	sprintf(N,"N=%d,",j/10);
	if ((j<=170) & (j>10))
	{
		sprintf(CH,"CH=%d",(j-10)/10); //vpis doby chlazen
	}
	else
	{
		sprintf(CH,"CH=%d", 16);
	}
	LCD_Clear();
  	_delay_ms(2);
	LCD_Position(0 , 0);
   	LCD_WriteString("R50/63 Pracuji!");
	LCD_Position(1 , 0);
   	LCD_WriteString(N);
	LCD_WriteString(CH);
	_delay_ms(100);
	if (stop==1){break;}
}

break;

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
case 3:  //////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////	

if (poprve==1)
{
	poprve=0;
	for (int j=250; j>0; j--) //natkn forem a chlazen
	{
		if (stop==1){ break;}
		LCD_Clear();
  		_delay_ms(2);
		sprintf(N,"N=%d",j/10);
		LCD_Position(0 , 0);
       	LCD_WriteString("R50/63 Pracuji!");
		LCD_Position(1 , 0);
   		LCD_WriteString(N);
		if (stop==1){break;}
		if (j==8)  {setb(PORTB,7);}  //zaven forem 
		_delay_ms(100);
		if (stop==1){break;}
	}
}

for (int j=250;j>0;j--)
{
	if (stop==1){break;}
	if (j==250){setb(PORTB,6);}   //uznut noem
	if (j==247){setb(PORTB,5);}   //odjet na plnn druh formy
	if (j==220){setb(PORTB,4);}   //zajet 1. trn
	if (j==10) {clrb(PORTB,4);}   //odjet 1. trn
	if (j==8)  {clrb(PORTB,7);}   //uzaven druhch forem, oteven prvnch
	sprintf(N,"N=%d,",j/10);
	if ((j<=220) & (j>10))
	{
		sprintf(CH,"CH=%d",(j-10)/10); //vpis doby chlazen
	}
	else
	{
		sprintf(CH,"CH=%d", 21);
	}
	LCD_Clear();
  	_delay_ms(2);
	LCD_Position(0 , 0);
    LCD_WriteString("R50/63 Pracuji!");
	LCD_Position(1 , 0);
   	LCD_WriteString(N);
	LCD_WriteString(CH);
	_delay_ms(100);
	if (stop==1){break;}
}

for (int j=250;j>0;j--) //natkn + chlazen forem 2
{
	if (stop==1){break;}
	if (j==250){clrb(PORTB,6);}   //uznut noem
	if (j==247){clrb(PORTB,5);}   //odjet na plnn druh formy
	if (j==220){setb(PORTB,3);}   //zajet 2. trn
	if (j==10) {clrb(PORTB,3);}   //odjet 2. trn
	if (j==8)  {setb(PORTB,7);}   //uzaven forem
	sprintf(N,"N=%d,",j/10);
	if ((j<=220) & (j>10))
	{
		sprintf(CH,"CH=%d",(j-10)/10); //vpis doby chlazen
	}
	else
	{
		sprintf(CH,"CH=%d", 21);
	}
	LCD_Clear();
  	_delay_ms(2);
	LCD_Position(0 , 0);
   	LCD_WriteString("R50/63 Pracuji!");
	LCD_Position(1 , 0);
   	LCD_WriteString(N);
	LCD_WriteString(CH);
	_delay_ms(100);
	if (stop==1){break;}
}
	
break;

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
case 4:  //////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////	


if (poprve==1)
{
	poprve=0; //zajzn vykonvn tto sti
	for (int j=150; j>0; j--) //natkn forem
	{
		if (stop==1){ break;}
		LCD_Clear();
  		_delay_ms(2);
		sprintf(N,"N=%d",j/10);
		LCD_Position(0 , 0);
       	LCD_WriteString("R50/63 Pracuji!");
		LCD_Position(1 , 0);
   		LCD_WriteString(N);
		if (j==8)  {setb(PORTB,7);}  //zaven forem 
		_delay_ms(100);
		if (stop==1){break;}
	}
}

for (int j=150;j>0;j--)
{
	if (stop==1){break;}
	if (j==150){setb(PORTB,6);}   //uznut noem
	if (j==147){setb(PORTB,5);}   //odjet na plnn druh formy
	if (j==120){setb(PORTB,4);}   //zajet 1. trn
	if (j==10) {clrb(PORTB,4);}   //odjet 1. trn
	if (j==8)  {clrb(PORTB,7);}   //uzaven druhch forem, oteven prvnch
	sprintf(N,"N=%d,",j/10);
	if ((j<=120) & (j>10))
	{
		sprintf(CH,"CH=%d",(j-10)/10); //vpis doby chlazen
	}
	else
	{
		sprintf(CH,"CH=%d", 11);
	}
	LCD_Clear();
  	_delay_ms(2);
	LCD_Position(0 , 0);
    LCD_WriteString("R50/63 Pracuji!");
	LCD_Position(1 , 0);
   	LCD_WriteString(N);
	LCD_WriteString(CH);
	_delay_ms(100);
	if (stop==1){break;}
}

for (int j=150;j>0;j--) //natkn + chlazen forem 2
{
	if (stop==1){break;}
	if (j==150){clrb(PORTB,6);}   //uznut noem
	if (j==147){clrb(PORTB,5);}   //odjet na plnn druh formy
	if (j==120){setb(PORTB,3);}   //zajet 2. trn
	if (j==10) {clrb(PORTB,3);}   //odjet 2. trn
	if (j==8)  {setb(PORTB,7);}   //uzaven forem
	sprintf(N,"N=%d,",j/10);
	if ((j<=120) & (j>10))
	{
		sprintf(CH,"CH=%d",(j-10)/10); //vpis doby chlazen
	}
	else
	{
		sprintf(CH,"CH=%d", 11);
	}
	LCD_Clear();
  	_delay_ms(2);
	LCD_Position(0 , 0);
   	LCD_WriteString("R50/63 Pracuji!");
	LCD_Position(1 , 0);
   	LCD_WriteString(N);
	LCD_WriteString(CH);
	_delay_ms(100);
	if (stop==1){break;}
}
		break;




} // os switch (potvrzeno)
  
} // od ((start==1) & (stop==0))

}
}
